<!-- markdownlint-disable -->
<h1 align="center">
    best-of-ml-rust
    <br>
</h1>

<p align="center">
    <strong>🏆&nbsp; A ranked list of awesome machine learning Rust libraries. Updated weekly.</strong>
</p>

<p align="center">
    <a href="https://best-of.org" title="Best-of Badge"><img src="http://bit.ly/3o3EHNN"></a>
    <a href="#Contents" title="Project Count"><img src="https://img.shields.io/badge/projects-85-blue.svg?color=5ac4bf"></a>
    <a href="#Contribution" title="Contributions are welcome"><img src="https://img.shields.io/badge/contributions-welcome-green.svg"></a>
    <a href="https://github.com/e-tony/best-of-ml-rust/releases" title="Best-of Updates"><img src="https://img.shields.io/github/release-date/e-tony/best-of-ml-rust?color=green&label=updated"></a>
</p>

This curated list contains 85 awesome open-source projects with a total of 51K stars grouped into 4 categories. All projects are ranked by a project-quality score, which is calculated based on various metrics automatically collected from GitHub and different package managers. If you like to add or update projects, feel free to open an [issue](https://github.com/e-tony/best-of-ml-rust/issues/new/choose), submit a [pull request](https://github.com/e-tony/best-of-ml-rust/pulls), or directly edit the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml). Contributions are very welcome!

> 🧙‍♂️  Discover other [best-of lists](https://best-of.org) or [create your own](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

## Contents

- [Machine Learning Frameworks](#machine-learning-frameworks) _41 projects_
- [Text Data & NLP](#text-data--nlp) _30 projects_
- [Image Data](#image-data) _8 projects_
- [Data Loading & Extraction](#data-loading--extraction) _6 projects_

## Explanation
- 🥇🥈🥉&nbsp; Combined project-quality score
- ⭐️&nbsp; Star count from GitHub
- 🐣&nbsp; New project _(less than 6 months old)_
- 💤&nbsp; Inactive project _(6 months no activity)_
- 💀&nbsp; Dead project _(12 months no activity)_
- 📈📉&nbsp; Project is trending up or down
- ➕&nbsp; Project was recently added
- ❗️&nbsp; Warning _(e.g. missing/risky license)_
- 👨‍💻&nbsp; Contributors count from GitHub
- 🔀&nbsp; Fork count from GitHub
- 📋&nbsp; Issue count from GitHub
- ⏱️&nbsp; Last update timestamp on package manager
- 📥&nbsp; Download count from package manager
- 📦&nbsp; Number of dependent projects

<br>

## Machine Learning Frameworks

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_General-purpose machine learning and deep learning frameworks._

<details><summary><b><a href="https://github.com/apache/tvm">tvm</a></b> (🥇19 ·  ⭐ 6.5K) - Open deep learning compiler stack for cpu, gpu and specialized.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/apache/tvm) (👨‍💻 520 · 🔀 1.8K · 📥 500 · 📋 1.8K - 7% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/apache/tvm
	```
</details>
<details><summary><b><a href="https://github.com/weld-project/weld">weld</a></b> (🥇17 ·  ⭐ 2.6K · 💤) - High-performance runtime for data analytics applications. <code><a href="http://bit.ly/3aKzpTv">BSD-3</a></code></summary>

- [GitHub](https://github.com/weld-project/weld) (👨‍💻 36 · 🔀 230 · 📦 2 · 📋 160 - 41% open · ⏱️ 04.04.2020):

	```
	git clone https://github.com/weld-project/weld
	```
</details>
<details><summary><b><a href="https://github.com/tensorflow/rust">rust</a></b> (🥇16 ·  ⭐ 3K) - Rust language bindings for TensorFlow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/tensorflow/rust) (👨‍💻 37 · 🔀 240 · 📋 130 - 21% open · ⏱️ 18.02.2021):

	```
	git clone https://github.com/tensorflow/rust
	```
</details>
<details><summary><b><a href="https://github.com/ballista-compute/ballista">ballista</a></b> (🥇16 ·  ⭐ 2.2K) - Distributed compute platform implemented in Rust, and powered by.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/ballista-compute/ballista) (👨‍💻 37 · 🔀 140 · 📋 250 - 26% open · ⏱️ 11.03.2021):

	```
	git clone https://github.com/ballista-compute/ballista
	```
</details>
<details><summary><b><a href="https://github.com/xaynetwork/xaynet">xaynet</a></b> (🥇15 ·  ⭐ 110) - Xaynet represents an agnostic Federated Machine Learning framework to.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/xaynetwork/xaynet) (🔀 18 · 📋 30 - 10% open · ⏱️ 23.03.2021):

	```
	git clone https://github.com/xaynetwork/xaynet/
	```
</details>
<details><summary><b><a href="https://github.com/maciejkula/rustlearn">rustlearn</a></b> (🥈13 ·  ⭐ 480 · 💤) - Machine learning crate for Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/maciejkula/rustlearn) (👨‍💻 9 · 🔀 43 · 📋 12 - 66% open · ⏱️ 21.06.2020):

	```
	git clone https://github.com/maciejkula/rustlearn
	```
</details>
<details><summary><b><a href="https://github.com/raskr/rust-autograd">rust-autograd</a></b> (🥈12 ·  ⭐ 280) - Tensors and differentiable operations (like TensorFlow) in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/raskr/rust-autograd) (👨‍💻 10 · 🔀 19 · ⏱️ 31.12.2020):

	```
	git clone https://github.com/raskr/rust-autograd
	```
</details>
<details><summary>Show 34 hidden projects...</summary>

- <b><a href="https://github.com/sonos/tract">tract</a></b> (🥇15 ·  ⭐ 900) - Tiny, no-nonsense, self-contained, Tensorflow and ONNX inference. <code>❗Unlicensed</code>
- <b><a href="https://github.com/wsmoses/Enzyme">Enzyme</a></b> (🥇15 ·  ⭐ 440) - High-performance automatic differentiation of LLVM. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-ml/linfa">linfa</a></b> (🥈14 ·  ⭐ 820) - A Rust machine learning framework. <code>❗Unlicensed</code>
- <b><a href="https://github.com/AtheMathmo/rusty-machine">rusty-machine</a></b> (🥈13 ·  ⭐ 1.2K · 💀) - Machine Learning library for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/spearow/juice">juice</a></b> (🥈13 ·  ⭐ 740) - The Hacker's Machine Learning Engine. <code>❗Unlicensed</code>
- <b><a href="https://github.com/autumnai/leaf">leaf</a></b> (🥈12 ·  ⭐ 5.5K · 💀) - Open Machine Intelligence Framework for Hackers. (GPU/CPU). <code>❗Unlicensed</code>
- <b><a href="https://github.com/LaurentMazare/tch-rs">tch-rs</a></b> (🥈12 ·  ⭐ 990) - Rust bindings for the C++ api of PyTorch. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Synerise/cleora">cleora</a></b> (🥈12 ·  ⭐ 300 · 🐣) - Cleora AI is a general-purpose model for efficient, scalable.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/vertexclique/orkhon">orkhon</a></b> (🥈12 ·  ⭐ 98) - Orkhon: ML Inference Framework and Server Runtime. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/Axect/Peroxide">Peroxide</a></b> (🥈11 ·  ⭐ 200) - Rust numeric library with R, MATLAB & Python syntax. <code>❗Unlicensed</code>
- <b><a href="https://github.com/tspooner/rsrl">rsrl</a></b> (🥈11 ·  ⭐ 94 · 💤) - A fast, safe and easy to use reinforcement learning framework in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/jackm321/RustNN">RustNN</a></b> (🥉10 ·  ⭐ 300 · 💀) - A neural network crate. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tedsta/deeplearn-rs">deeplearn-rs</a></b> (🥉10 ·  ⭐ 190 · 💀) - Neural networks in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/millardjn/alumina">alumina</a></b> (🥉10 ·  ⭐ 76) - A deep learning library for rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/torchrs/torchrs">torchrs</a></b> (🥉10 ·  ⭐ 76 · 💀) - Deep Learning in Rust with the PyTorch API. <code><a href="http://bit.ly/3rqEWVr">BSD-2</a></code>
- <b><a href="https://github.com/MikhailKravets/NeuroFlow">NeuroFlow</a></b> (🥉10 ·  ⭐ 52 · 💀) - Awesome deep learning crate. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/smartcorelib/smartcore">smartcore</a></b> (🥉9 ·  ⭐ 120) - SmartCore is a comprehensive library for machine learning and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/daniel-e/rustml">rustml</a></b> (🥉9 ·  ⭐ 46 · 💀) - Machine learning in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jramapuram/hal">hal</a></b> (🥉8 ·  ⭐ 75 · 💀) - Rust based Cross-GPU Machine Learning. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/diffeo/kodama">kodama</a></b> (🥉8 ·  ⭐ 48) - Fast hierarchical agglomerative clustering in Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/avinashshenoy97/RusticSOM">RusticSOM</a></b> (🥉8 ·  ⭐ 20) - Rust library for Self Organising Maps (SOM). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/messense/crfsuite-rs">crfsuite-rs</a></b> (🥉8 ·  ⭐ 13) - Rust binding to crfsuite. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/charles-r-earp/autograph">autograph</a></b> (🥉7 ·  ⭐ 99) - Machine Learning Library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/outbrain/fwumious_wabbit">fwumious_wabbit</a></b> (🥉7 ·  ⭐ 96 · 🐣) - Fwumious Wabbit, fast on-line machine learning.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/boncheolgu/tflite-rs">tflite-rs</a></b> (🥉7 ·  ⭐ 38) -  <code>❗Unlicensed</code>
- <b><a href="https://github.com/JonathanWoollett-Light/cogent">cogent</a></b> (🥉7 ·  ⭐ 24) - Simple neural network library for classification written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/epwalsh/rust-dl-webserver">rust-dl-webserver</a></b> (🥉7 ·  ⭐ 16 · ➕) - Example of serving deep learning models in Rust with.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/CasperN/drug">drug</a></b> (🥉7 ·  ⭐ 10 · 💀) - Differentiable Rust Graphs (neural network library). <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/epwalsh/batched-fn">batched-fn</a></b> (🥉7 ·  ⭐ 3) - Rust middleware for serving deep learning models with batched.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/Robbepop/prophet">prophet</a></b> (🥉6 ·  ⭐ 39 · 💀) - A simple neural net implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/yurytsoy/revonet">revonet</a></b> (🥉6 ·  ⭐ 14 · 💀) - Rust implementation of real-coded GA for solving optimization.. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/afck/fann-rs">fann-rs</a></b> (🥉6 ·  ⭐ 11 · 💀) - Rust wrapper for the Fast Artificial Neural Network library. <code><a href="http://bit.ly/37RvQcA">❗️LGPL-3.0</a></code>
- <b><a href="https://github.com/finalfusion/reductive">reductive</a></b> (🥉6) - Vector quantization. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/usamec/cntk-rs">cntk-rs</a></b> (🥉5 ·  ⭐ 20 · 💀) - Wrapper around Microsoft CNTK library. <code>❗Unlicensed</code>
</details>
<br>

## Text Data & NLP

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for processing, cleaning, manipulating, and analyzing text data as well as for diverse NLP tasks._

<details><summary><b><a href="https://github.com/huggingface/tokenizers">tokenizers</a></b> (🥇21 ·  ⭐ 4.4K) - Fast State-of-the-Art Tokenizers optimized for Research and.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/huggingface/tokenizers) (👨‍💻 40 · 🔀 320 · 📦 25 · 📋 400 - 21% open · ⏱️ 18.03.2021):

	```
	git clone https://github.com/huggingface/tokenizers
	```
</details>
<details><summary><b><a href="https://github.com/greyblake/whatlang-rs">whatlang-rs</a></b> (🥇15 ·  ⭐ 400) - Natural language detection library for Rust. Try demo online:.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/greyblake/whatlang-rs) (👨‍💻 14 · 🔀 27 · 📋 33 - 12% open · ⏱️ 11.03.2021):

	```
	git clone https://github.com/greyblake/whatlang-rs
	```
</details>
<details><summary><b><a href="https://github.com/guillaume-be/rust-bert">rust-bert</a></b> (🥈13 ·  ⭐ 520) - Rust native ready-to-use NLP pipelines and transformer-based.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/guillaume-be/rust-bert) (👨‍💻 9 · 🔀 38 · 📋 39 - 15% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/guillaume-be/rust-bert
	```
</details>
<details><summary><b><a href="https://github.com/pemistahl/lingua-rs">lingua-rs</a></b> (🥈13 ·  ⭐ 270) - The most accurate natural language detection library in the Rust.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/pemistahl/lingua-rs) (👨‍💻 2 · 🔀 4 · 📋 12 - 41% open · ⏱️ 31.01.2021):

	```
	git clone https://github.com/pemistahl/lingua-rs
	```
</details>
<details><summary><b><a href="https://github.com/lindera-morphology/lindera">lindera</a></b> (🥈13 ·  ⭐ 100) - A morphological analysis library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/lindera-morphology/lindera) (👨‍💻 6 · 🔀 11 · 📋 30 - 16% open · ⏱️ 16.01.2021):

	```
	git clone https://github.com/lindera-morphology/lindera
	```
</details>
<details><summary><b><a href="https://github.com/bminixhofer/nnsplit">nnsplit</a></b> (🥈12 ·  ⭐ 140) - Semantic text segmentation. For sentence boundary detection, compound.. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/bminixhofer/nnsplit) (👨‍💻 3 · 🔀 10 · 📦 2 · 📋 19 - 36% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/bminixhofer/nnsplit
	```
</details>
<details><summary>Show 24 hidden projects...</summary>

- <b><a href="https://github.com/snipsco/snips-nlu-rs">snips-nlu-rs</a></b> (🥇14 ·  ⭐ 320 · 💀) - Snips NLU rust implementation. <code>❗Unlicensed</code>
- <b><a href="https://github.com/bminixhofer/nlprule">nlprule</a></b> (🥇14 ·  ⭐ 310) - A fast, low-resource Natural Language Processing and Text.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/BurntSushi/aho-corasick">aho-corasick</a></b> (🥈11 ·  ⭐ 430) - A fast implementation of Aho-Corasick in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/christophertrml/rs-natural">rs-natural</a></b> (🥈11 ·  ⭐ 190 · 💀) - Natural Language Processing for Rust. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/finalfusion/finalfusion-rust">finalfusion-rust</a></b> (🥈11 ·  ⭐ 35) - finalfusion embeddings in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/guillaume-be/rust-tokenizers">rust-tokenizers</a></b> (🥈10 ·  ⭐ 74) - Rust-tokenizer offers high-performance tokenizers for modern.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/finalfusion/finalfrontier">finalfrontier</a></b> (🥈10 ·  ⭐ 61) - Context-sensitive word embeddings with subwords. In Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rth/vtext">vtext</a></b> (🥉9 ·  ⭐ 110 · 💤) - Simple NLP in Rust with Python bindings. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/dpar">dpar</a></b> (🥉9 ·  ⭐ 39) - Neural network transition-based dependency parser (in Rust). <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/stickeritis/sticker">sticker</a></b> (🥉9 ·  ⭐ 27 · ➕) - Succeeded by SyntaxDot: https://github.com/tensordot/syntaxdot. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/sentencepiece">sentencepiece</a></b> (🥉9 ·  ⭐ 6) - Rust binding for the sentencepiece library. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/DimaKudosh/word2vec">word2vec</a></b> (🥉8 ·  ⭐ 20 · 💀) - Rust interface to word2vec. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/cpcdoy/rust-sbert">rust-sbert</a></b> (🥉8 ·  ⭐ 15 · ➕) - Rust port of sentence-transformers.. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/alpino-tokenizer">alpino-tokenizer</a></b> (🥉8 ·  ⭐ 2) - Rust wrapper for the Alpino tokenizer. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/proycon/deepfrog">deepfrog</a></b> (🥉7 ·  ⭐ 13) - An NLP-suite powered by deep learning. <code><a href="http://bit.ly/2M0xdwT">❗️GPL-3.0</a></code>
- <b><a href="https://github.com/sebpuetz/lumberjack">lumberjack</a></b> (🥉7 ·  ⭐ 11 · 💀) - Read and modify constituency trees in Rust. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/danieldk/seqalign">seqalign</a></b> (🥉7 · 💤) - Sequence alignments. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code>
- <b><a href="https://github.com/tensordot/syntaxdot">syntaxdot</a></b> (🥉6 ·  ⭐ 9 · 🐣) - Neural syntax annotator, supporting sequence labeling,.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/reinfer/blingfire-rs">blingfire-rs</a></b> (🥉5 ·  ⭐ 11 · 💤) - Rust wrapper for the BlingFire tokenization library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/danieldk/ohnomore">ohnomore</a></b> (🥉5) - Explorations in lemmatization. <code>❗Unlicensed</code>
- <b><a href="https://github.com/allenai/rustberta-snli">rustberta-snli</a></b> (🥉4 ·  ⭐ 11 · 🐣) - A Rust implementation of a RoBERTa classification.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/danieldk/wordpieces">wordpieces</a></b> (🥉4 ·  ⭐ 1) - Split tokens into word pieces. <code>❗Unlicensed</code>
- <b><a href="https://github.com/Aleph-Alpha/aleph-alpha-tokenizer">aleph-alpha-tokenizer</a></b> (🥉3 ·  ⭐ 5 · 💤) - A rustic language tokenizer library inspired by.. <code>❗Unlicensed</code>
- <b><a href="https://github.com/andrew-johnson-4/misspeller">misspeller</a></b> (🥉3) - Take correctly spelled words and return common spelling mistakes. <code>❗Unlicensed</code>
</details>
<br>

## Image Data

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for image & video processing, manipulation, and augmentation as well as libraries for computer vision._

<details><summary><b><a href="https://github.com/twistedfall/opencv-rust">opencv-rust</a></b> (🥇14 ·  ⭐ 610) - Rust bindings for OpenCV 3 & 4. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/twistedfall/opencv-rust) (👨‍💻 25 · 🔀 62 · 📋 170 - 4% open · ⏱️ 24.03.2021):

	```
	git clone https://github.com/twistedfall/opencv-rust
	```
</details>
<details><summary>Show 7 hidden projects...</summary>

- <b><a href="https://github.com/EmbarkStudios/texture-synthesis">texture-synthesis</a></b> (🥇14 ·  ⭐ 1.3K · 📈) - Example-based texture synthesis written in Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/atomashpolskiy/rustface">rustface</a></b> (🥈13 ·  ⭐ 270) - Face detection library for the Rust programming language. <code>❗Unlicensed</code>
- <b><a href="https://github.com/rust-cv/cv">cv</a></b> (🥉11 ·  ⭐ 82) - Rust CV mono-repo. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/mpizenberg/visual-odometry-rs">visual-odometry-rs</a></b> (🥉9 ·  ⭐ 27 · 💀) - Visual Odometry in Rust (vors). <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code>
- <b><a href="https://github.com/visioncortex/visionmagic">visionmagic</a></b> (🥉9 ·  ⭐ 23 · 🐣) - Collection of vision & graphics algorithms. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jerry73204/rust-cv-convert">rust-cv-convert</a></b> (🥉7 ·  ⭐ 9 · 🐣) - Type conversion among popular Rust computer vision libraries. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/mermoldy/image-ssd">image-ssd</a></b> (🥉5 ·  ⭐ 1) - A Rust library for object detection via SSD MobileNet. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>
<br>

## Data Loading & Extraction

<a href="#contents"><img align="right" width="15" height="15" src="https://git.io/JtehR" alt="Back to top"></a>

_Libraries for loading, collecting, and extracting data from a variety of data sources and formats._

<details><summary><b><a href="https://github.com/timberio/vector">vector</a></b> (🥇23 ·  ⭐ 6.8K) - High-performance, high-reliability observability data pipeline. <code><a href="http://bit.ly/3postzC">MPL-2.0</a></code></summary>

- [GitHub](https://github.com/timberio/vector) (👨‍💻 120 · 🔀 450 · 📥 32K · 📋 3.3K - 35% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/timberio/vector
	```
</details>
<details><summary><b><a href="https://github.com/ritchie46/polars">polars</a></b> (🥈16 ·  ⭐ 1.3K) - Rust DataFrame library. <code><a href="http://bit.ly/34MBwT8">MIT</a></code></summary>

- [GitHub](https://github.com/ritchie46/polars) (👨‍💻 21 · 🔀 56 · 📋 240 - 14% open · ⏱️ 26.03.2021):

	```
	git clone https://github.com/ritchie46/polars
	```
</details>
<details><summary><b><a href="https://github.com/nevi-me/rust-dataframe">rust-dataframe</a></b> (🥉10 ·  ⭐ 270) - A Rust DataFrame implementation, built on Apache Arrow. <code><a href="http://bit.ly/3nYMfla">Apache-2</a></code></summary>

- [GitHub](https://github.com/nevi-me/rust-dataframe) (👨‍💻 4 · 🔀 18 · 📋 38 - 31% open · ⏱️ 26.10.2020):

	```
	git clone https://github.com/nevi-me/rust-dataframe
	```
</details>
<details><summary>Show 3 hidden projects...</summary>

- <b><a href="https://github.com/rayon-rs/rayon">rayon</a></b> (🥈15 ·  ⭐ 4.9K) - Rayon: A data parallelism library for Rust. <code>❗Unlicensed</code>
- <b><a href="https://github.com/jerry73204/tch-serde">tch-serde</a></b> (🥉9 ·  ⭐ 3 · ➕) - Serialize/Deserialize tch-rs types with serde. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
- <b><a href="https://github.com/jerry73204/rust-tfrecord">rust-tfrecord</a></b> (🥉8 ·  ⭐ 13 · ➕) - A Rust crate that reads and writes tfrecord files. <code><a href="http://bit.ly/34MBwT8">MIT</a></code>
</details>

---

## Related Resources

- [**best-of-ml-python**](https://github.com/ml-tooling/best-of-ml-python): A ranked list of awesome machine learning Python libraries.
- [**best-of-ml-julia**](https://github.com/e-tony/best-of-ml-julia): A ranked list of awesome machine learning Julia libraries.

## Contribution

Contributions are encouraged and always welcome! If you like to add or update projects, choose one of the following ways:

- Open an issue by selecting one of the provided categories from the [issue page](https://github.com/e-tony/best-of-ml-rust/issues/new/choose) and fill in the requested information.
- Modify the [projects.yaml](https://github.com/e-tony/best-of-ml-rust/blob/main/projects.yaml) with your additions or changes, and submit a pull request. This can also be done directly via the [Github UI](https://github.com/e-tony/best-of-ml-rust/edit/main/projects.yaml).

If you like to contribute to or share suggestions regarding the project metadata collection or markdown generation, please refer to the [best-of-generator](https://github.com/best-of-lists/best-of-generator) repository. If you like to create your own best-of list, we recommend to follow [this guide](https://github.com/best-of-lists/best-of/blob/main/create-best-of-list.md).

For more information on how to add or update projects, please read the [contribution guidelines](https://github.com/e-tony/best-of-ml-rust/blob/main/CONTRIBUTING.md). By participating in this project, you agree to abide by its [Code of Conduct](https://github.com/e-tony/best-of-ml-rust/blob/main/.github/CODE_OF_CONDUCT.md).

## License

[![CC0](https://mirrors.creativecommons.org/presskit/buttons/88x31/svg/by-sa.svg)](https://creativecommons.org/licenses/by-sa/4.0/)
